Iterations = 0
Buildinglist = { "powr", "apwr", "barr", "tent", "proc", "weap", "fact", "dome", "atek", "stek", "spen", "syrd", "kenn", "tsla", "ftur", "fix", "hpad", "afld" }
Unitproducers = {"barr", "tent", "weap", "spen", "syrd", "kenn", "hpad", "afld"}
SpreadBlacklist = {}

ObjectiveSyncer = function()
--Syncing new Objectives
	Trigger.OnObjectiveAdded(Mainplayer, function(player,obid)
		CoopObjectiveDesc = player.GetObjectiveDescription(obid)
		CoopObjectiveType = player.GetObjectiveType(obid)
		
		for _, PID in ipairs(CoopPlayers) do
			if PID ~= player then
				CoopObj = "CoopObj" .. PID.Name .. CoopObjectiveDesc
				if CoopObjectiveType == "Primary" then
					CoopObj = AddPrimaryObjective(PID, CoopObjectiveDesc)
				end
				if CoopObjectiveType == "Secondary" then
					CoopObj = AddSecondaryObjective(PID, CoopObjectiveDesc)
				end
			end
		end
	end)
	
--Syncing Completed Objectives
	--[[Trigger.OnObjectiveCompleted(Mainplayer, function(player,obid)
		CoopObjectiveDesc = player.GetObjectiveDescription(obid)
		
		for _, PID in ipairs(CoopPlayers) do
			if PID ~= player then
				CoopObj = "CoopObj" .. PID.Name .. CoopObjectiveDesc
				PID.MarkCompletedObjective(CoopObj)
			end
		end
	end)

	Trigger.OnObjectiveFailed(Mainplayer, function(player,obid)
		CoopObjectiveDesc = player.GetObjectiveDescription(obid)
		
		for _, PID in ipairs(CoopPlayers) do
			if PID ~= player then
				CoopObj = "CoopObj" .. PID.Name .. CoopObjectiveDesc
				PID.MarkFailedObjective(CoopObj)
			end
		end
	end)
	]]
--Syncing Failed Objectives

end

GoodSpread  = function()
	GoodUnits = GoodGuy.GetGroundAttackers()
	FilteredList = {}
	for _, UID in ipairs(GoodUnits) do
		FilterPassed = true
		for _, FID in ipairs(SpreadBlacklist) do
			if UID.Type == FID then
				FilterPassed = false
			end
		end
		if FilterPassed == true then
			table.insert(FilteredList, UID)
		end
	end
	
	for _, UID in ipairs(FilteredList) do
		if SkipFirstPlayer ~= nil and CoopCurrent == 1 and #CoopPlayers > 1 then
			CoopCurrent = CoopCurrent + 1
		end
		CurrentPlayer = CoopPlayers[CoopCurrent]
		UID.Owner = CurrentPlayer
		CoopCurrent = CoopCurrent + 1
		if CoopCurrent > #CoopPlayers then
			CoopCurrent = 1
		end
	end
end

CoopInit = function()
	Multi1 = Player.GetPlayer("Multi1")
	Multi2 = Player.GetPlayer("Multi2")
	Multi3 = Player.GetPlayer("Multi3")
	Multi4 = Player.GetPlayer("Multi4")
	Multi5 = Player.GetPlayer("Multi5")
	Neutral = Player.GetPlayer("Neutral")
	GoodGuy = Player.GetPlayer("GoodGuy")
	
	CoopPlayers = {};
	table.insert(CoopPlayers, Greece)
	if Multi1 ~= nil then
		table.insert(CoopPlayers, Multi1)
	end
	if Multi2 ~= nil then
		table.insert(CoopPlayers, Multi2)
	end
	if Multi3 ~= nil then
		table.insert(CoopPlayers, Multi3)
	end
	if Multi4 ~= nil then
		table.insert(CoopPlayers, Multi4)
	end
	if Multi5 ~= nil then
		table.insert(CoopPlayers, Multi5)
	end
	
	CoopPlayersSet = {}
	for _, CoID in ipairs(CoopPlayers) do
		CoopPlayersSet[CoID] = true
	end
	
	Mainplayer = CoopPlayers[1]
	
	if SkipFirstPlayer == nil and Stopspread == nil then
		InitialUnits = Mainplayer.GetGroundAttackers()
		for _, UID in ipairs(InitialUnits) do
			UID.Owner = GoodGuy
		end
	end
	
	ObjectiveSyncer()
	
	if Map.LobbyOption("oremines") == "oreon"  then
		ExtraMines = {ExtraMine1, ExtraMine2, ExtraMine3, ExtraMine4, ExtraMine5, ExtraMine6, ExtraMine7, ExtraMine8, ExtraMine9, ExtraMine10}
		for i,MID in pairs (ExtraMines) do
			AddMine = Actor.Create("mine", true, { Location = MID.Location, Owner = Neutral })
		end
		ExtraDiamondMines = {ExtraDiamondMine1, ExtraDiamondMine2, ExtraDiamondMine3, ExtraDiamondMine4, ExtraDiamondMine5, ExtraDiamondMine6, ExtraDiamondMine7, ExtraDiamondMine8, ExtraDiamondMine9, ExtraDiamondMine10}
		for i,DMID in pairs (ExtraDiamondMines) do
			AddMine = Actor.Create("gmine", true, { Location = DMID.Location, Owner = Neutral })
		end
	end
	
	EProMultiplier = Map.LobbyOption("prmp")
	if Map.LobbyOption("prmp") == "prmppc"  then
		EProMultiplier = #CoopPlayers-1
	end
	
	--Media.DisplayMessage("Enemy Multiplayer =" .. EProMultiplier)
	Trigger.OnAnyProduction(function(producingunit,producedunit,producttype)
		--Media.DisplayMessage("Actor Produced")
		AttackUnits = Enemyplayer.GetGroundAttackers()
		for i,EID in pairs (AttackUnits) do
			if producedunit == EID then
				for m=1,EProMultiplier do
					--Media.DisplayMessage("Actor Multiplied")
					CopyUnit = Actor.Create(producedunit.Type, true, { Location = producedunit.Location, Owner = Enemyplayer })
					CopyUnit.Scatter()
				end
			end
		end
	end)
	
	EnemyMultiplier = Map.LobbyOption("enmp")
	if Map.LobbyOption("enmp") == "enmppc"  then
		EnemyMultiplier = #CoopPlayers-1
	end

	EnemyUnits = Enemyplayer.GetGroundAttackers()
	for m=1,EnemyMultiplier do
		for i,EID in pairs (EnemyUnits) do
			CopyUnit = Actor.Create(EID.Type, true, { Location = EID.Location, Owner = Enemyplayer })
			CopyUnit.Scatter()
		end
	end
	
	CoopCurrent = 1
	
	MCVPlayers = {}
	if Map.LobbyOption("basesharing") ~= "1" then
        MCVPlayers = CoopPlayers
    end
	
	if Map.LobbyOption("basesharing") == "1" then
        table.insert(MCVPlayers, Mainplayer)
    end
	
	if Map.LobbyOption("basesharing") == "1" or Map.LobbyOption("basesharing") == "2" then
        BaseShare = true
    end
	
    CoopPrerequisites()
    PlayIntro()
end

CoopPrerequisites = function()
    if BaseShare == true then
        for i, BID in pairs(Buildinglist) do
            local coopbuild = "coop" .. BID
            Prerequbuildings = 0
            for i, PID in pairs(CoopPlayers) do
                for i, UID in pairs(PID.GetActorsByType(BID)) do
                    Primarybuilding = UID
                    Prerequbuildings = Prerequbuildings + 1
                end
            end
            for i, PID in pairs(CoopPlayers) do
                RealBuildings = PID.GetActorsByType(BID)
                FakeBuildings = PID.GetActorsByType(coopbuild)
                if Prerequbuildings > 0 and #FakeBuildings == 0 and #RealBuildings == 0 then
                    FakeFact = Actor.Create(coopbuild, true, {Owner = PID, Location = CPos.New(0, 0)})
                    if
                        FakeFact.Type == "cooptent" or FakeFact.Type == "coopbarr" or FakeFact.Type == "coopweap" or
                            FakeFact.Type == "coopkenn" or
                            FakeFact.Type == "coopsyrd" or
                            FakeFact.Type == "coopspen"
                     then
                        Trigger.OnProduction(
                            FakeFact,
                            function(Producer, Produced)
                                for i, PID2 in pairs(CoopPlayers) do
                                    for i, UID2 in pairs(PID2.GetActorsByType(BID)) do
                                        RemoteProducer = UID2
                                    end
                                end
                                if Producer.Type == "cooptent" or Producer.Type == "coopbarr" then
                                    RemoteExit = CVec.New(0, 1)
                                end
                                if Producer.Type == "coopweap" then
                                    RemoteExit = CVec.New(1, 1)
                                end
                                if Producer.Type == "coopkenn" then
                                    RemoteExit = CVec.New(0, 0)
                                end
                                if Producer.Type == "coopsyrd" or Producer.Type == "coopspen" then
                                    RemoteExit = CVec.New(2, 2)
                                end
                                Remoteunit =
                                    Actor.Create(
                                    Produced.Type,
                                    true,
                                    {Owner = Producer.Owner, Location = RemoteProducer.Location + RemoteExit}
                                )
                                Remoteunit.Scatter()
                                Produced.Destroy()
                            end
                        )
                    end
                end
                if Prerequbuildings == 0 or #RealBuildings > 0 then
                    for i, UID in pairs(FakeBuildings) do
                        UID.Destroy()
                    end
                end
            end
        end
    end
	
	if Stopspread == nil then
		GoodSpread()
	end
	
	if Stopspread ~= nil then
		if Stopspread == false then
			GoodSpread()
		end
	end
	
	Trigger.AfterDelay(5, CoopPrerequisites)
end

PlayIntro = function()
	VideoStyle = 2
	if Map.LobbyOption("fmvstyle") == "fmvfull" then
		VideoStyle = 1
	end
	if Map.LobbyOption("fmvstyle") == "fmvmixed" then
		VideoStyle = 2
	end
	if Map.LobbyOption("fmvstyle") == "fmvradar" then
		VideoStyle = 3
	end
	Media.StopMusic()
    if FMVExtra ~= nil then
		if VideoStyle <= 2 then
			Media.PlayMovieFullscreen(FMVExtra, PlayBriefing)
		end
		
		if VideoStyle == 3 then
			Media.PlayMovieInRadar(FMVExtra, PlayBriefing)
		end
	else
	PlayBriefing()
	end
end

PlayBriefing = function()	
	if FMVBriefing ~= nil then
		if VideoStyle <= 2 then
			Media.PlayMovieFullscreen(FMVBriefing, PlayOpening)
		end
	
		if VideoStyle == 3 then
			Media.PlayMovieInRadar(FMVBriefing, PlayOpening)
		end
	else
	PlayOpening()
	end
end

PlayOpening = function()
	if FMVOpening ~= nil then
		if VideoStyle == 1 then
			Media.PlayMovieFullscreen(FMVOpening, PlaySoundtrack)
		end
	
		if VideoStyle >= 2 then
			Media.PlayMovieInRadar(FMVOpening, PlaySoundtrack)
		end
    else
	PlaySoundtrack()
	end
end

PlaySoundtrack = function()
	Media.PlayMusic()
end